import { GeneratorOptions } from '@babel/generator';
import { File, Statement } from '@babel/types';
import { ParserOptions } from '@babel/parser';
import { DeepArray, InjectPath, Substitutions } from './types';
export * from './types';
export default class BabelParserGenerator {
    ast: File;
    options: ParserOptions;
    reservedKeywords: Set<string>;
    constructor(code?: string);
    isReservedKeyword(keyword: string): boolean;
    safeWord(keyword: string): string;
    templateAst(code: string, codePath?: string | DeepArray<string>, options?: ParserOptions, substitutions?: Substitutions): Statement | Statement[];
    generate(options?: GeneratorOptions): string;
    prepend(code: string, injectPath?: InjectPath, codePath?: string | DeepArray<string>, options?: ParserOptions, substitutions?: Substitutions): number;
    append(code: string, injectPath?: InjectPath, codePath?: string | DeepArray<string>, options?: ParserOptions, substitutions?: Substitutions): number;
    getAst(injectPath?: InjectPath): Statement | Statement[];
    setAst(injectPath: string | number | DeepArray<string | number> | undefined, value: Statement | Statement[]): Statement | Statement[];
}
